#ifndef CDDETECTORIMP_H
#define CDDETECTORIMP_H
#include "CDQuickHull3D.h"

namespace Spr {;

#define CD_EPSILON	HULL_EPSILON
#define CD_INFINITE	HULL_INFINITE

class CDFace;
class CDConvex;
class CDConvexPair;
class CDConvexPairWithNormal;
class SGScene;

///	BBoxm̌DĂ trueD
bool BBoxIntersection(Affinef postureA, Vec3f centerA, Vec3f extentA,
					  Affinef postureB, Vec3f centerB, Vec3f extentB);

///	GJKŋL_
bool FindCommonPoint(const CDConvex& a, const CDConvex& b,
					 const Affinef& a2w, const Affinef& b2w,
					 Vec3d& v, Vec3d& pa, Vec3d& pb);

/// GJKōŋߖT_΂
void FindClosestPoints(const CDConvex& a, const CDConvex& b,
					   const Affinef& a2w, const Affinef& b2w,
					   Vec3d& pa, Vec3d& pb);

/**	Փ˔茋(̌`߂@\/@߂@\t)	*/
class CDContactAnalysis{
public:
	/// \addtogroup quickHull QuickHull̂߂̒_ƕ
	//@{
	///	ʂoΕϊ_QuickHull̂ŁCCDFaceVtxs.
	typedef std::vector<CDFace*> Vtxs;	
	static Vtxs vtxs;					///<	QuickHull̒_
	static CDQHPlanes<CDFace> planes;	///<	
	bool isValid;						///<	̃|S͗LH
	//@}
	/**	ʕ̌`߂D
		ʂ́Cʕ\ʂ vtxs.begin() Ԃl܂łɁC
		ʕ\钸_C planes.begin  planes.end ̂
		deleted==false ̂̂ɓĕԂD
		convex[0], convex[1]̒_Worldnɕϊϊs
		af0, af1 ɓnȂ΂ȂȂD	*/
	CDFace** FindIntersection(CDConvexPair& cp, Affinef* af);
	/**	̌`̖@ϕāCՓ˂̖@߂D
		AB̏Փ˂̖@́C̖ʂ̂CA̖ʂ̖@̐ϕ
		B̖ʂ̖@̐ϕ̂ɂȂD	*/
	void IntegrateNormal(CDConvexPairWithNormal& cp, Affinef* af);
	/**	@̌vZDO̖@̌ɕ̂𓮂C
		̂𗣂čŋߖT_߂D	*/
	void CalcNormal(CDConvexPairWithNormal& cp,  Affinef* af);
	/**	ʓ_ƌ̌`̕`	*/
	void Draw(CDConvexPair& cp, Affinef afw, SGScene* s);
};

}
#endif
