#ifndef FITYPEDESC_H
#define FITYPEDESC_H

#include "FIIterator.h"
#include <Base/BaseUtility.h>
#include <WinBasis/WBUtility.h>
#include <set>
#include <map>
#include <algorithm>

/**	@page FITypeDesc hLgIuWFNgƌ^Lq
	C++̍\̂f[^oꍇȂǁC\̂f[^ɂ́C
	ϐϐ̌^ƌ͂ȂD
	ŁC^Lq^IuWFNg(FITypeDesc)gċLqĂD

	f[^oۂɂ́CoCif[^
	hLgIuWFNg̃vpeBD
	̍ہC^LqăvpeBvpeB^LD

	f[^ǂݏoۂɂ́C^LqȂCoCif[^
	\̂\zD

	邽߂̃C^tF[XƂāC
	- ǂݏoReLXg̍쐬		FIContext* ReadContext();
	- ݃ReLXg̍쐬		FIContext* WriteContext();
	- ReLXg̊J				void ReleaseContext(FIContext*);
	- ̃tB[hǂݏo֐		bool Read(void* ctx, void* ptr, int sz)
	- ̃tB[h̃f[^	void Write(void* ctx, void* ptr, int sz, FIString fn)
	- tB[h̃O[vɓ		void EnterGroup(FIString fn);
	- O[v甲D				void ExitGroup();
	pӂD
*/

namespace Spr {;

/**	FIVVector̊{NXD
	xN^ւ̃[hƃZ[ũT|[gɕKvȉz֐p	*/
class FIVVectorBase{
public:
	virtual size_t VItemSize() = 0;
	virtual size_t VSize() = 0;
	virtual void VResize(size_t s) = 0;
	virtual char* VBegin() = 0;
	virtual char* VEnd() = 0;
	virtual void VInsert(int pos, void* v) = 0;
	virtual void VPushBack(void* v) = 0;
	virtual void VPushBack() = 0;
	virtual void VPopBack() = 0;
};
/**	FITypeDesc łstd::vector
	xN^ւ̃[hƃZ[ũT|[gɕKvȉz֐D
	FITypeDesc ͕ʂvector ܂ރNX̓T|[gȂD*/
template <class T>
class FIVVector: public FIVVectorBase, public std::vector<T>{
	virtual size_t VItemSize(){ return sizeof(T); }
	virtual size_t VSize(){ return size(); }
	virtual void VResize(size_t s){ resize(s); }
	virtual char* VBegin(){ return (char*)&*begin(); }
	virtual char* VEnd(){ return (char*) &*end(); }
	virtual void VInsert(int pos, void* v){ insert(begin()+pos, *(T*)v); }
	virtual void VPushBack(void* v){ push_back(*(T*)v); }
	virtual void VPushBack(){ push_back(T()); }
	virtual void VPopBack(){ pop_back(); }
public:
	FIVVector(){}
	FIVVector(const std::vector<T>& v):std::vector<T>(v){}
	FIVVector& operator=(const std::vector<T>& v){ *(std::vector<T>*)this = v; return *this; }
};

class FIDocNodeBase;
class FIDocNodePos;

class FITypeDescDb;
///	^\
class SPR_DLL FITypeDesc:public UTRefCount{
public:
	///	R[h̃tB[h\
	class SPR_DLL Field{
	public:
		Field(): length(1), lengthFieldOffset(0), lengthFieldSize(0), bReference(false), bVector(false){}
		~Field();
		///	o
		UTString name;
		///	^
		UTRef<FITypeDesc> type;
		///	z̗vfD
		int length;
		///	vfʂ̃tB[hƂꍇ̃tB[h
		UTString lengthFieldName;
		///	vfʂ̃tB[hƂꍇ̃ItZbg
		int lengthFieldOffset;
		///	vfʂ̃tB[hƂꍇTCY
		int lengthFieldSize;
		///	vectorǂ
		int bVector;
		///	QƂǂ
		bool bReference;
		///	f[^̃TCY
		size_t Size();
		///
		void Print(std::ostream& os) const;
		///	m[hC\̂̃tB[hǂݏo
		bool Read(char*& to, size_t align, FIDocNodeBase* node, FIIterator& ctx);
		///	m[hɍ\̂̃tB[hoD
		void Write(FIDocNodeBase* node, FIIterator& ctx, const char*& from);
	};
	///	gݗČ^킷ꍇɎg
	class SPR_DLL Composit: public std::vector<Field>{
	public:
		///	f[^̃TCYԂ
		int Size(){ return Size(""); }
		///	f[^̃TCYԂ
		int Size(FIString id);
		///
		void Print(std::ostream& os) const;
		///	m[hC\̂ǂݏo
		bool Read(char*& to, size_t align, FIDocNodeBase* node, FIIterator& ctx);
		///	m[hɍ\̂oD
		void Write(FIDocNodeBase* node, FIIterator& ctx, const char*& from);
	};
protected:
	///	^
	UTString typeName;
	///	f[^̒
	size_t size;
	///	gݗČ^̒g̋LqDP^̏ꍇ́Csize() == 0
	Composit composit;

	friend class FITypeDescDb;
public:
	///	^GUID
	WBGuid guid;
	///	RXgN^
	FITypeDesc():size(0){}
	///	RXgN^
	FITypeDesc(UTString tn, int sz=0): typeName(tn), size(sz){}
	///	
	~FITypeDesc(){}
	///	C++̃NX`̕񂩂Č^\IuWFNg\zD
	bool Init(const char* clsDef, FITypeDescDb& db);
	///
	void Print(std::ostream& os) const;
	///	m[hC\̂ǂݏo
	int Read(void* to, FIDocNodeBase* node, FIString id);
	int Read(void* to, FIDocNodeBase* node){ return Read(to, node, ""); }
	///	\̂ǂݏo
	bool Read(char*& to, size_t align, FIDocNodeBase* node, FIIterator& ctx);
	///	m[hցC\̂o
	int Write(FIDocNodeBase* node, const void* from);
	///	ցC\̂o
	void Write(FIDocNodeBase* node, FIIterator& ctx, const char*& from, UTString id);
	///	^
	UTString GetTypeName() const { return typeName; }
	///	GUID
	const GUID& GetGuid() const { return guid; };
	///	^̃TCY
	size_t Size() { return size; }
	///	gݗČ^̗vf
	Composit& GetComposit(){ return composit; }
};
inline bool operator < (const FITypeDesc& d1, const FITypeDesc& d2){
	return d1.GetTypeName().compare(d2.GetTypeName()) < 0;
}
///	^̃f[^x[X
class SPR_DLL FITypeDescDb: public UTRefCount{
public:
	///	Reǐ^
	typedef std::set< UTRef<FITypeDesc>, UTContentsLess< UTRef<FITypeDesc> > > Db;
	struct ProtoDesc{
		FIString fileType;
		UTRef<FITypeDesc> desc;
	};
	typedef std::vector<ProtoDesc> ProtoDescs;
protected:
	FIString prefix;			///<	ÔvtBbNX̕
	Db db;						///<	FITypeDesc ĂRei
	static ProtoDescs protoDescs;
public:
	///	
	~FITypeDescDb();
	static const ProtoDescs& GetProtoDescs(){ return protoDescs; }
	/**	^f[^x[Xɓo^D	*/
	void RegisterDesc(FITypeDesc* n){
		if (prefix.length() && n->typeName.compare(0, prefix.length(), prefix) == 0){
			n->typeName = n->typeName.substr(prefix.length());
		}
		db.insert(n);
	}
	/**	^vg^CvXgɓo^	*/
	void RegisterProto(FITypeDesc* n);
	/**	REG_RECORD}Ngp֐D^ƍ\̂̒`̕
		^𐶐Cf[^x[Xɓo^D	*/
	void Register(const char* type, const char* def, bool bProto=false){
		UTRef<FITypeDesc> desc = new FITypeDesc(type);
		desc->Init(def, *this);
		RegisterDesc(desc);
		if(bProto) RegisterProto(desc);
	}
	/**	^Prefix ݒD
		^FindŌۂɁCL[PrefixL[ł^D	*/
	void SetPrefix(FIString p);
	/**	^𖼑O猟D
		@param tn	^Dprefix ͏ȗĂ悢D	*/
	FITypeDesc* Find(UTString tn);
	///	DB̌^̕\
	void Print(std::ostream& os) const ;
};

///	FIVVector̃TCYwDx ɂ̓tB[h(oϐ)w肷D
#define VSIZE(x)

///	P^o^D
#define REG_FIELD(type)	RegisterDesc( new FITypeDesc(#type, sizeof(type)) )
/**	hLg烍[h\ȃNX̒`D
	NX{NXꍇ	*/
#define DEF_RECORDBASE(Type, Base, Def)					\
	struct Type: public Base Def;						\
	static const char* classNameOf##Type = #Type;		\
	static const char* classDefOf##Type = #Def;			\

/**	hLg烍[h\ȃNX̒`D
	{NXꍇ	*/
#define DEF_RECORD(Type, Def)							\
	struct Type Def;									\
	static const char* classNameOf##Type = #Type;		\
	static const char* classDefOf##Type = #Def;			\

/**	DER_RECORD Œ`^o^D*/
#define REG_RECORD(Type)	\
	Register(classNameOf##Type, classDefOf##Type)

/**	DER_RECORD Œ`^vg^CvƂĂo^D*/
#define REG_RECORD_PROTO(Type)	\
	Register(classNameOf##Type, classDefOf##Type, true)

/**	@page TypeDesc ^NX
C++̍\̐錾𕶎ƂĎ󂯎C^͂D
gFwb_t@CŁC`
DEF_RECORD( Test, {
	int x;
	char y;
}
)

āCNX̒`sC
.cppt@C̉̊֐̒
	REG_RECORD(Test);
ēo^܂D
*/
}
#endif
