#pragma once
#ifndef PHCONTACTENGINE_H
#define PHCONTACTENGINE_H

#include "PHSolid.h"
#include <SceneGraph/SGScene.h>
#include <Physics/PHConvexPair.h>
#include <Collision/CDCollisionEngine.h>
#include <Collision/CDPolyhedron.h>
#include <float.h>

namespace Spr{;


/**	ڐG͌vZGWD	*/
class PHContactEngine:public SGBehaviorEngine, CDCollisionListener{
public:
	///	Ώۃt[Ƃ̃f[^
	class FrameRecord:public CDUserRecord{
	public:
		///@name	UpdateChacheōXVϐ
		//@{
		/**	ŌɐڐG = LbVp[^ŌɍXVD
			ڐGɁCLbVXV̂ŁCcount ݂̎Ɠ
			Փ˂NƂӖD	*/
		unsigned count;
		//	t[()Pʂ̃p[^
		Vec3f cog, vel, angVel;			///<	dSCxCpx
		Vec3f pos, lastPos;				///<	ʒuCŌ̈ʒu
		Quaternionf ori, lastOri;		///<	CǑ
		//@}
		void UpdateCache(int c);		///<	LbVϐ̂ȂǂĂD
		PHSolid* solid;					///<	Ώۍ
		FrameRecord(){ count = -1; }	///<	s
	};
	///	Ώۃt[΂Ƃ̃f[^
	class FramePairRecord:public CDUserRecord{
	public:
		Vec3f cocog;					///<	2̂̏dS̒_(Όn)
		Vec3f reflexForce;				///<	R
		Vec3f reflexTorque;				///<	R͂ɂgN(cocogn)
		Vec3f frictionForce;			///<	C
		Vec3f frictionTorque;			///<	C͂ɂgN(cocogn)
		///@name	Όnł̓ǂݏo
		//@{
		///	R
		Vec3f GetReflexForce(){ return reflexForce; }
		///	R͂̃gN
		Vec3f GetReflexTorque(){ return reflexTorque + (cocog^reflexForce); }
		///	C
		Vec3f GetFrictionForce(){ return frictionForce; }
		///	C͂̃gN
		Vec3f GetFrictionTorque(){ return frictionTorque + (cocog^frictionForce); }
		//@}
		
		///	f[^̃NAD
		void Clear(){
			reflexForce = reflexTorque = frictionForce = frictionTorque = Vec3f();
		}
		///	͂̍ől𐧖񂷂D
		void LimitForces(){
			bool b = false;
			b |= LimitForce(reflexForce);
			b |= LimitForce(frictionForce);
			b |= LimitForce(reflexTorque);
			b |= LimitForce(frictionTorque);
			if (b){
				reflexForce = frictionForce = reflexTorque = frictionTorque = Vec3f();
			}
		}
	protected:
		bool LimitForce(Vec3f& f){
			float sq = f.square();
			const float MF = 200000;
			if (!(sq < MF*MF)){
				return true;
			}
			return false;
		}
	};
	///	ʌ`΂Ƃ̃f[^
	class ConvexPairRecord:public CDUserRecord{
	public:
		///@name	R͂̌vZ
		//@{
		float area;							///<	̖ʐ
		Vec3f reflexSpringForce;			///<	΂˂ɂR
		Vec3f reflexDamperForce;			///<	_p[ɂR
		Vec3f reflexSpringTorque;			///<	΂˂ɂRgN(commonPointn)
		Vec3f reflexDamperTorque;			///<	_p[ɂRgN(commonPointn)
		Vec3f reflexForcePoint;				///<	R͂̍p_(commonPointn)
		//@}

		///@nameČvZ
		//@{
		Vec3f transFrictionBase[2];			///<	iÎ~Cpol̒[_([Jt[n)
		float rotSpring;					///<	]΂˂̐L(WA)
		Vec3f dynaFric;						///<	C
		Vec3f dynaFricMom;					///<	C͂̃[g(commonPointn)
		Vec3f frictionForce;				///<	C
		Vec3f frictionTorque;				///<	CgN(C͂̍p_  (reflexForcePoint+commonPoint)n)
		enum FrictionState{ STATIC, DYNAMIC };
		FrictionState frictionState;		///<	C̏
		//@}
		///@name	΍Wnł̓ǂݏo
		//@{
		///	olɂR͂̍p_
		Vec3f GetReflexForcePoint(CDConvexPair* cp){ return reflexForcePoint + cp->commonPoint;}
		///	olɂR
		Vec3f GetReflexSpringForce(){ return reflexSpringForce;}
		///	_pɂR
		Vec3f GetReflexDamperForce(){ return reflexDamperForce;}
		///	R
		Vec3f GetReflexForce(){ return reflexSpringForce + reflexDamperForce;}

		///	C
		Vec3f GetFrictionForce(){ return frictionForce; }
		///	CgN
		Vec3f GetFrictionTorque(CDConvexPair* cp){ return frictionTorque + (GetReflexForcePoint(cp)^frictionForce); }
		//@}
	};
private:
	bool firstLoadedCall;					///<	Loadedŕ񏉊Ȃ悤ɂ邽߂̃tO
	float area;								///<	Փ˕̖ʐ
	float convertedMass;					///<	Z
	float reflexSpring;						///<	olv
	float reflexDamper;						///<	_pv
	float frictionSpring;					///<	C̃olW
	float frictionDamper;					///<	C̃_pW
	float staticFriction;					///<	Î~CW
	float dynamicFriction;					///<	CW
protected:
	int listenerPos;						///<	CDContactEngine̒ł̃Xïʒu
	int frameRecordPos;						///<	CDContactEngine̒ł̃t[Pʂ̃[UR[ḧʒu
	int framePairRecordPos;					///<	CDContactEngine̒ł̃t[ΒPʂ̃[UR[ḧʒu
	int convexPairRecordPos;				///<	CDContactEngine̒ł̓ʌ`ΒPʂ̃[UR[ḧʒu
	std::vector< std::pair<DWORD, DWORD> > inactiveList;
											///<	ANeBuȃyAꗗ([hɂgp)

	UTRef<CDCollisionEngine> collisionEngine;///<	Փ˔GW
public:	
	SGOBJECTDEF(PHContactEngine);
	std::vector< std::vector<DWORD> > inactiveListBackups;
											//<		Z[uɔĊoĂ
	PHSolids solids;						///<	yieB@̑Ώۂ̍
	size_t nSolidsInitilized;				///<	solidŝǂ܂łς݂D
	///
	PHContactEngine();
	CDCollisionEngine* GetCollisionEngine(){ return collisionEngine; }
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	int GetListenerPos(){ return listenerPos; }
	///	FrameRecordCDCollisionEngine̒ł̈ʒu
	int GetFrameRecordPos(){ return frameRecordPos; }
	///	FramePairRecordCDCollisionEngine̒ł̈ʒu
	int GetFramePairRecordPos(){ return framePairRecordPos; }
	///	ConvexPairRecordCDCollisionEngine̒ł̈ʒu
	int GetConvexPairRecordPos(){ return convexPairRecordPos; }
	///	FrameRecord̎擾
	FrameRecord* GetFrameRecord(SGFrame* fr){
		return (FrameRecord*)collisionEngine->GetFrameRecord(collisionEngine->GetFrameID(fr), frameRecordPos);
	}
	/**	FramePairRecord̎擾
		FramePairRecord̓t[̑΂Ƃ1D
		(fr1,fr2)(fr2,fr1)œǂ񂾏ꍇCǂ炩ЕNULLԂD
		(fr1,fr2)ŒlꂽȂ΁CFramePairRecordf1ɉ͂D
	*/
	FramePairRecord* GetFramePairRecord(SGFrame* fr1, SGFrame* fr2){
		CDFramePairWithRecord* fp = collisionEngine->GetFramePair(fr1, fr2);
		if (fp) return UTRef<FramePairRecord>(fp->records[framePairRecordPos]);
		return NULL;
	}
	///	ANeBułȂt[΂ǉ
	void AddInactive(int f1, int f2);

	///	[h̏CCollisionEngine ɃR[obNo^DCollisionEngineȂ΍D[UĂяoƂ͂ȂD
	virtual void Loaded(SGScene* scene);
	///	ALoadedĂ
	virtual void Init(SGScene* scene);
	///	ڐG͂̕`
	void Render(GRRender* r, SGScene* s);
protected:
	///
	int GetPriority() const { return SGBP_CONTACTENGINE; }
	///	Ԃ dt i߂D(ȂCListener  Collide ׂĂ̏D)
	virtual void Step(SGScene* s){}
	///	solidsNAD
	virtual void Clear(SGScene* s);
	///	t[mՓ˂ĂꍇCڐG͂̑OɌĂяoDR͌vZ̏sD
	void Before(SGScene* scene, CDFramePairWithRecord* fr);
	/**	t[mՓ˂ĂꍇCڐG͂̒ɓʌ`΂ƂɌĂяoD
		ڐGʐςƍR͂̌vZsD*/
	virtual void Analyzed(SGScene* scene, CDFramePairWithRecord* fr, CDGeometryPair* geom, CDConvexPairWithRecord* conv, CDContactAnalysis* analyzer);
	/**	t[mՓ˂ĂꍇCՓˉ͂IĂt[΂ɂ1xĂяoD
		R͂̒CC͌vZs	*/
	void After(SGScene* scene, CDFramePairWithRecord* fr);
	///	R͌vZ
	void CalcReflexForce(PHContactEngine::FrameRecord** fr, CDConvexPairWithRecord* cp,
		PHContactEngine::ConvexPairRecord* rec, CDContactAnalysis* analyzer);
	///	3p`Pʂ̍R͌vZ
	void CalcTriangleReflexForce(CDConvexPairWithRecord* cp, PHContactEngine::ConvexPairRecord* rec,
		Vec3f p0, Vec3f p1, Vec3f p2, Vec3f cog, Vec3f vel, Vec3f angVel);
	void CalcFriction(PHContactEngine::FrameRecord** fr, PHContactEngine::FramePairRecord* fpr, CDConvexPairWithNormal* cp,
		PHContactEngine::ConvexPairRecord* rec);
	void DrawForce(CDConvexPair& cp, PHContactEngine::ConvexPairRecord& cpr, Affinef afw, GRRender* render, SGScene* scene);

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
};


}
#endif

