#ifndef HASE_HD3DRMFRAME_H
#define HASE_HD3DRMFRAME_H
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include <WinBasis/WBWin.h>
#include "WXD3Affine.h"
#include <WinDX/Base/WxComBase.h>
#include <d3drm.h>

namespace Spr {

 
class WXRMVisual;
class WXRMMesh;
class WXRMLight;
class WXRMColFrame;

///	IDirect3DRMObject̃bpNX
class WXRMObject:public WXUnknown
	{
	protected:
	char* name;
	IDirect3DRMObject*& PRMObj() const
		{
		return (IDirect3DRMObject*&) intf;	//	IDirect3DRMObjectւ̃|C^
		}
	virtual IDirect3DRMObject* Clone() const;	//	IuWFNg̕ĕԂD
	static void _cdecl DestroyCallback(IDirect3DRMObject* , void* pArg);
												//	
	public:
	WXRMObject(const WXRMObject& o);
	WXRMObject(IDirect3DRMObject* o=NULL);
	~WXRMObject();
	virtual void BeforeCreate();
	virtual bool AfterCreate();
	virtual bool Create();
	virtual void Release();
	//	O
	const char* Name();
	void Name(const char* n);
	//	Interface's GUID
	virtual const IID& InterfaceID() const;
	bool Check(IUnknown* pUk) const;
	//	Zq
	const WXRMObject& operator = (const WXRMObject& o);
	bool operator == (const WXRMObject& o) const
		{
		return PRMObj() == o.PRMObj();
		}
	};
//----------------------------------------------------------------------------
/**	Direct3DRM̃t[.
	؍\ArWAibVȂǁjƌێ.
	؍\̐eɑ΂Ĉʒuݒł.
	IDirect3DRMFrame3̑Ɏg.

  ؍\̑ɂ
	
	:et[ɒǉqt[AbVÁAet[܂
	ɕێB
	
	:	\begin{verbatim}
	WXD3RM rm;
	WXRMFrame fr1;
	void BuildScene()
		{
		WXRMFrame fr2;
		WXRMMesh mesh("mesh.X()");
		fr1.Add(mesh);
		fr2.Add(mesh);
		rm.Scene().Add(fr1);
		rm.Scene().Add(fr2);
		fr1.DelThis();				//	fr1V[폜
		}	
		//	ϐ fr2, mesh ͏邪AV[ɒǉꂽt[
		//	bV͎cB
		//	fr1ɒǉꂽbVc邽߁Afr1̃bVBuildScene()
		//	ĂԂтɑB
	\end{verbatim}	*/
class WXRMFrame:public WXRMObject{
public:
#if DIRECTDRAW_VERSION >= 0x0600
	typedef IDirect3DRMFrame3 intf_type;
#elif DIRECTDRAW_VERSION >= 0x0500
	typedef IDirect3DRMFrame2 intf_type;
#else
	typedef IDirect3DRMFrame intf_type;
#endif
protected:
	void CreateFrame();
	intf_type*& PFrame() const
		{
		return (intf_type*&) intf;
		}
	public:
	//	\z
	///	Rs[RXgN^
	WXRMFrame(const WXRMFrame& f):WXRMObject(f){}
	///	Ȃ̃RXgN^
	WXRMFrame(intf_type* f=NULL):WXRMObject(f){}
	///	t@Cǂݏo
	WXRMFrame(const char* fname);
	bool Create(){
		if (!PFrame()) CreateFrame();
		return PFrame()!=NULL;
	}
	///	.Xt@Cǂݏo ؍\ۂƃt@C烍[hB
	bool Load(const char* fname);
	
	///	intf_type ֕ϊ
	operator intf_type* () const
		{
		return PFrame();
		}
	///	intf_type ̃\bȟĂяop
	intf_type * operator ->()
		{
		bool b = Create();
		assert(b);
		return PFrame();
		}
	//	ȉt[̑
	///	O name ̎qt[T
	WXRMFrame Find(const char* name);
	///	fr qt[Ȃ true
	bool Find(const WXRMFrame& fr);
	///	et[
	WXRMFrame Parent();
	///	et[̐ݒ
	virtual void Parent(intf_type* pf);
	//	qt[ǉ
	virtual void Child(WXRMFrame& fr){Add(fr);}
	//	qt[ǉ
	virtual void Add(WXRMFrame& fr);
	void Add(const WXRMFrame& fr){WXRMFrame f=fr; Add(fr);}
	///	qt[폜
	virtual void Del(const WXRMFrame& fr);
	///	et[폜
	virtual void DelThis();
	///	qt[̐
	int NChild();
	///	iԖڂ̎qt[
	WXRMFrame Child(int i);
	//	ȉrWAi_Oʂ́AMeshȂǁj̑
	///	rWA̒ǉ
	virtual void Add(WXRMVisual& vis);
	void Add(const WXRMVisual& vis);
	///	rWA̍폜
	virtual void Del(const WXRMVisual& vis);
	///	rWA̐
	int NVisual();
	///	iԖڂ̃rWA
	WXRMVisual Visual(int i);
	///	O name ̃rWA
	WXRMVisual Visual(const char* name);

	//	ȉ̑
	///	̒ǉ
	virtual void Add(const WXRMLight& light);
	///	̍폜
	virtual void Del(const WXRMLight& light);
	///	̐
	int NLight();
	///	iԖڂ̌
	WXRMLight Light(int i);
	///	O name ̌
	WXRMLight Light(const char* name);

	///	ׂĂ̎qt[ArWAA폜
	virtual void Clear();

	///	x
	REAL RotAngle();
	WXD3Vec3 RotAxis();
	virtual void Rot(const WXD3Vec3& axis, D3DVALUE rVel);
	WXD3Vec3 Vel();
	virtual void Vel(const WXD3Vec3& vel);

	///	et[猩ʒu
	virtual void Ori(const WXD3Vec3& ez, const WXD3Vec3& ey, const WXRMFrame& frRef=WXRMFrame());
	virtual void Pos(const WXD3Vec3& v, const WXRMFrame& frRef = WXRMFrame());
	///	et[猩̃t[̈ʒu
	WXD3Affine AfParent();
	///	et[猩̃t[̈ʒu̐ݒ
	virtual void AfParent(const WXD3Affine& af);
	///	WorldWn猩ʒu
	virtual WXD3Affine AfWorld();
	///	WorldWn猩ʒu̐ݒ
	virtual void AfWorld(const WXD3Affine& af);
	//	̑
	///
	virtual const IID& InterfaceID() const;
	///
	virtual const CLSID& ClassID() const;
	};
}	//	namespace Spr
#endif