#ifndef Spr_DDRAW_DDSURF_H
#define Spr_DDRAW_DDSURF_H
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <WinBasis/WBWin.h>
#include <WinDX/Base/WXCallback.h>
#include <ddraw.h>

namespace Spr {
class WXDDSurfaceBase;
class WXDDSurface;
class WXDDFrontSurface;
class WXDDFlipSurface;
class WXDDSurfaceDesc;
class WXDDraw;

/**	(z)VRAM.
	surface Ƃ̓OtBbNp̃obt@̂ƁB
	DirectDrawSurface͏ȂƂȉ̋@\
	All direct draw surfaces have these method at least. */
class WXDDSurfaceBase{
	protected:
	WXDDraw* pWXDD;

	public:
	WXDDSurfaceBase(){pWXDD=NULL;}
	///	obt@̊m
	virtual bool Create() = 0;
	///	obt@̊J
	virtual void Release() = 0;
	/**	ubN]Bsurf ̓eɃRs[B
		@param surf Rs[T[tFCX
		@param dest Rs[`̈̍̓_̍W
		@param sz	Rs[̈̃TCY
		@param src	Rs[T[tFCX̍̓_̍W	*/
	virtual bool Blt(WXDDSurface& surf, POINT dest, SIZE sz, POINT src, DWORD flags=DDBLT_WAIT);
	virtual bool Blt(WXDDSurface& surf, POINT dest, SIZE size, DWORD flags=DDBLT_WAIT){POINT pt={0,0}; return Blt(surf, dest, size, pt, flags);}
	virtual bool Blt(WXDDSurface& surf, DWORD flags=DDBLT_WAIT){POINT pt={0,0}; SIZE size={-1, -1}; return Blt(surf, pt, size, flags);}
	/**	I[o[CDsurf ̏ɃI[o[CD
		@param surf Rs[T[tFCX
		@param ptDest	I[o[C`̈̍̓_̍W
		@param szDest	I[o[C̈̃TCY
		@param ptSrc	I[o[CT[tFCX̍̓_̍W
		@param szDest	I[o[C̗̈̃TCY	*/
	virtual bool Overlay(POINT ptDest, WXDDSurface& surf, SIZE szDest, POINT ptSrc, SIZE szSrc, DWORD flags=DDOVER_SHOW , DDOVERLAYFX* fx=NULL);
	virtual bool Overlay(POINT ptDest, WXDDSurface& surf, SIZE szDest, POINT ptSrc, DWORD flags=DDOVER_SHOW , DDOVERLAYFX* fx=NULL){ SIZE szSrc = {-1,-1}; return Overlay(ptDest, surf, szDest, ptSrc, szSrc, flags, fx); }
	virtual bool Overlay(POINT ptDest, WXDDSurface& surf, SIZE szDest, DWORD flags=DDOVER_SHOW , DDOVERLAYFX* fx=NULL){ POINT ptSrc = {0,0}; return Overlay(ptDest, surf, szDest, ptSrc, flags, fx); }
	virtual bool Overlay(POINT ptDest, WXDDSurface& surf, DWORD flags=DDOVER_SHOW , DDOVERLAYFX* fx=NULL){ SIZE szDest = {-1,-1}; return Overlay(ptDest, surf, szDest, flags, fx); }
	virtual bool Overlay(WXDDSurface& surf, DWORD flags=DDOVER_SHOW , DDOVERLAYFX* fx=NULL){ POINT ptDest = {0,0}; return Overlay(ptDest, surf, flags, fx); }
	/**	I[o[C̒~D*/
	virtual bool StopOverlay(WXDDSurface& surf){ return false; }

	/**	NAAT[tFCX̓hԂB
		@param	color	T[tFCXhԂF	*/
	virtual bool Clear(DWORD color=0, DWORD flags=DDBLT_WAIT)=0;
	/**	NAAT[tFCX̋`̈̓hԂB
		@param	pt		`̈̍̓_̍W
		@param	sz		`̈̑傫
		@param	color	T[tFCXhԂF	*/
	virtual bool Clear(POINT pt, SIZE sz, DWORD color=0, DWORD flags=DDBLT_WAIT)=0;
	///	foCXReLXg̎擾(K`悵IxɊJ邱)
	virtual HDC GetDC()=0;
	///	foCXReLXg̊J
	virtual void ReleaseDC()=0;
	///	obt@ĂȂƂmF
	virtual bool Restore()=0;
	///	obt@̑傫(pixelP)
	virtual SIZE Size()=0;
	///	FsNZlɕϊ
	virtual DWORD ColorToPixel(COLORREF col)=0;
	///	1oCg̃sNZ
	virtual DWORD PixelPerByte()=0;
	///	1sNZ̃oCg
	virtual DWORD BytePerPixel()=0;
	///	obt@̋`̈ւ̒ڃANZX̊Jn
	virtual bool Lock(POINT pt, SIZE sz)=0;
	///	obt@Ŝւ̒ڃANZX̊Jn
	virtual bool Lock()=0;
	///	obt@ւ̒ڃANZX̏I
	virtual void Unlock()=0;
	///	ysڂ̍s̃sNZ̃AhX
	virtual BYTE* Line(DWORD y)=0;
	///	s
	virtual DWORD NLine()=0;
	///	s̒(byteP)
	virtual DWORD LineLen()=0;
	///	T[tFCXWXDDraw
	virtual void DDraw(WXDDraw& dd);
	WXDDraw& DDraw(){return *pWXDD;}
	WXDDraw* PWXDD(){return pWXDD;}
	///	
	virtual WXDDSurfaceDesc& Desc()=0;
	enum PixelFormatT{
		RGB555,
		RGB565,
		RGB16=RGB565,
		RGB24,
		RGB32,
		Y221,
		YUY2,
		UYVY,
		VYUY,
		vyuy
	};
	void PixelFormat(WXDDSurfaceBase::PixelFormatT t);
protected:
	virtual bool OverlayImp(RECT* prcDest, WXDDSurface& surf, RECT* prcSrc, DWORD flags, DDOVERLAYFX* fx)=0;
	virtual bool BltImp(WXDDSurface& surf, POINT dest, SIZE sz, POINT src, DWORD flags)=0;
};

///	surface ̋@\ƏԂێ\
class WXDDSurfaceDesc: public DDSURFACEDESC{
protected:
	DWORD lineLen;
	RECT rcLock;
	SIZE szLock;
	bool bLock;
	void Clear();

public:
	DWORD pixelPerByte;
	DWORD bytePerPixel;
	DWORD bitPerPixel;

	WXDDSurfaceDesc();
	WXDDSurfaceDesc(const DDSURFACEDESC& desc);
	void Caps(DWORD caps);
	DWORD Caps();
	SIZE Size() const;
	void Size(const SIZE& sz);
	void PixelFormat(WXDDSurfaceBase::PixelFormatT t);
	void Calc();
	friend class WXDDSurface;
};

///	IDirectDrawSurface̊{NX
class WXDDSInterface
	{
	public:
	WXDDSInterface();
	WXDDSInterface(IDirectDrawSurface*);
	WXDDSInterface(const WXDDSInterface& cidds);
	~WXDDSInterface();
	void Release();
	IDirectDrawSurface* pDDS;
	operator IDirectDrawSurface*(){return pDDS;}
	IDirectDrawSurface2* pDDS2;
	operator IDirectDrawSurface2*(){return pDDS2;}
#if DIRECTDRAW_VERSION >= 0x0500
	IDirectDrawSurface3* pDDS3;
	operator IDirectDrawSurface3*(){return pDDS3;}
#endif
#if DIRECTDRAW_VERSION >= 0x0700
	IDirectDrawSurface7* pDDS7;
	operator IDirectDrawSurface7*(){return pDDS7;}
#endif

#if DIRECTDRAW_VERSION >= 0x0700
	IDirectDrawSurface7* operator ->(){return pDDS7;}
	typedef IDirectDrawSurface7 IDirectDrawSurfaceLast;
#elif DIRECTDRAW_VERSION >= 0x0500
	IDirectDrawSurface3* operator ->(){return pDDS3;}
	typedef IDirectDrawSurface3 IDirectDrawSurfaceLast;
#else
	IDirectDrawSurface2* operator ->(){return pDDS2;}
	typedef IDirectDrawSurface2 IDirectDrawSurfaceLast;
#endif
	bool operator ==(const WXDDSInterface& d)const {return pDDS==d.pDDS;}
	bool operator >(const WXDDSInterface& d)const {return pDDS>d.pDDS;}
	bool operator <(const WXDDSInterface& d)const {return pDDS<d.pDDS;}
	WXDDSInterface operator =(const WXDDSInterface& d);
	};
/**	ʓI direct draw surface.
	Direct3D̕`ɂ WXD3Device,_uobt@ɂ WXDDFlipSurface
	p.
	obNobt@Ƃėp邱Ƃł.
*/
class WXDDSurface:public WXDDSurfaceBase, public WXDDSInterface{
public:
	typedef WXDDSurfaceBase baseclass;
protected:
	virtual bool Create(bool bCallCallback);
	virtual void Release(bool bCallCallback);
	WXDDSurfaceDesc descOld;
	HDC hDC;
	bool bCallDeleteCallbacks;
	friend WXDDFlipSurface;

public:
	WXDDSurfaceDesc desc;
	WXCallbacks<WXDDSurface> createCallbacks;
	WXCallbacks<WXDDSurface> releaseCallbacks;
	WXCallbacks<WXDDSurface> deleteCallbacks;

	WXDDSurface();
	WXDDSurface(IDirectDrawSurface* intf);
	~WXDDSurface();
	
	///	Create() ̑O obt@̑傫Zbg
	virtual void Size(const SIZE& sz){desc.Size(sz);}
	virtual SIZE Size();
	///	Create() ̑O DDSCAPS Zbg
	virtual void Caps(DWORD caps){desc.Caps(caps);}
	virtual DWORD Caps(){return desc.Caps();}

	//	Override WXDDSurfaceBase's methods.
	bool Create(){return Create(true);}
	void Release(){Release(true);}
	virtual bool Clear(DWORD color=0, DWORD flags=DDBLT_WAIT);
	virtual bool Clear(POINT pt, SIZE sz, DWORD color=0, DWORD flags=DDBLT_WAIT){ return ClearImp(pt, sz, color, flags); }
	virtual bool Lock(POINT pt, SIZE sz);
	virtual bool Lock(){POINT pt={0,0}; SIZE sz={-1,-1};return Lock(pt,sz);}
	virtual void Unlock();
	virtual HDC GetDC();
	virtual void ReleaseDC();
	virtual bool Restore();
	virtual bool IsLost();
	virtual DWORD ColorToPixel(COLORREF col);
	virtual DWORD PixelPerByte(){return desc.pixelPerByte;}
	virtual DWORD BytePerPixel(){return desc.bytePerPixel;}
	virtual DWORD LineLen(){return desc.lineLen;}
	virtual DWORD NLine(){return desc.rcLock.bottom - desc.rcLock.top;}
	virtual BYTE* Line(DWORD y){return (desc.bLock) ? (BYTE*)desc.lpSurface+desc.lPitch*y : NULL;}
	virtual WXDDSurfaceDesc& Desc(){ return desc; }
	virtual bool StopOverlay(WXDDSurface& surf);
protected:
	virtual bool OverlayImp(RECT* prcDest, WXDDSurface& surf, RECT* prcSrc, DWORD flags, DDOVERLAYFX* fx);
	virtual bool BltImp(WXDDSurface& surf, POINT dest, SIZE sz, POINT src, DWORD flags);
	virtual bool ClearImp(POINT pt, SIZE sz, DWORD color, DWORD flags);
	friend class WXDDFrontSurface;
};

///	EBhȆ傫Ǘ
class WXDDWindowManage
	{
	protected:
	HWND hWnd;
	WINDOWPLACEMENT* pWndPlaceOld;
	WINDOWPLACEMENT* pMainWndPlaceOld;

	public:
	WXDDWindowManage();
	~WXDDWindowManage();
	///	EChËʒu pt 傫 sz ɂ
	virtual bool FitWindow(POINT pt, SIZE sz);
	///	EBhËʒuƑ傫L
	virtual void SaveWindowPlace();
	///	ŌɋL^ʒuƑ傫ɖ߂
	virtual bool RestoreWindowPlace();
	///	ĂEBhẼnh
	HWND HWnd(){return hWnd;}
	///	EChE̐ݒ
	virtual void HWnd(HWND wnd){hWnd = wnd;}
	///	pt, sz XN[Wnɕϊ
	void ClientToScreen(POINT* pt, SIZE* sz);
	///	EBhẼNCAg̈̑傫
	SIZE Size();
	};

///	\̃obt@
class WXDDFrontSurface:public WXDDSurfaceBase, public WXDDWindowManage{
public:
	typedef WXDDSurfaceBase baseclass;
protected:
	IDirectDrawClipper* pClipper;

public:
	WXDDFrontSurface();
	~WXDDFrontSurface();
	///	Create() ̑Oɐݒ
	void HWnd(HWND wnd){WXDDWindowManage::HWnd(wnd);}
	HWND HWnd(){return WXDDWindowManage::HWnd();}

	//	Override WXDDWindowManage's methods.
	void ClientToScreen(POINT* pt, SIZE* sz);

	//	Override WXDDSurfaceBase's methods.
	bool Create();
	void Release();
	bool IsLost();
	bool Restore();
	bool Clear(DWORD color=0, DWORD flags=DDBLT_WAIT);
	bool Clear(POINT pt, SIZE sz, DWORD color=0, DWORD flags=DDBLT_WAIT);
	bool FitWindowToSurface();
	void Unlock();
	HDC GetDC();
	void ReleaseDC();
	/**	obt@ւ̒ڃANZX̊Jn.
		obt@ڃANZXł́ANbsOłȂ߁A
		ɏEBhEȂǂ𖳎ĕ`悵Ă܂B*/
	bool Lock(POINT pt, SIZE sz);
	bool Lock(){POINT pt={0,0}; SIZE sz={-1,-1};return Lock(pt,sz);}
	SIZE Size(){return WXDDWindowManage::Size();}
	DWORD ColorToPixel(COLORREF col);
	DWORD PixelPerByte();
	DWORD BytePerPixel();
	DWORD LineLen();
	DWORD NLine();
	BYTE* Line(DWORD y);
	virtual WXDDSurfaceDesc& Desc();
	virtual bool StopOverlay(WXDDSurface& surf);
protected:
	bool BltImp(WXDDSurface& surf, POINT dest, SIZE sz, POINT src, DWORD flags);
	bool OverlayImp(RECT* prcDest, WXDDSurface& surf, RECT* prcSrc, DWORD flags, DDOVERLAYFX* fx);
	bool SetClipper();
};

struct WXDDSInterfaces:public std::vector<WXDDSInterface>
	{
	WXDDSInterfaces();
	int cur;
	int Cur(){return cur;}
	WXDDSInterface& CurDDS(){return begin()[cur];}
	void Cur(int c);
	};

}	//	namespace Spr

#endif